/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

   CONSTANTS

   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
#define START_DELIMITER                                    0x7E
#define LENGTH_MSB                                         0x00
#define LENGTH_LSB                                         2
#define CHECKSUM                                           0xFF
#define IO_DATA_SAMPLE_API_FRAME_PACKET_SIZE               22
#define BAUD_RATE                                          9600
#define ONE_SECOND                                         1000

/* -

API FRAME NAMES AND VALUES

                                                                  - */
#define API_FRAME_AT                                       0x08
#define API_FRAME_AT_QUEUE_PARAMETER_VALUE                 0x09
#define API_FRAME_ZIGBEE_TRANSMIT_REQUEST                  0x10
#define API_FRAME_EXPLICIT_ADDRESSING_ZIGBEE_COMMAND_FRAME 0x11
#define API_FRAME_REMOTE_COMMAND_REQUEST                   0x17
#define API_FRAME_CREATE_SOURCE_ROUTE                      0x21
#define API_FRAME_COMMAND_RESPONSE                         0x88
#define API_FRAME_MODEM_STATUS                             0x8A
#define API_FRAME_ZIGBEE_TRANSMIT_STATUS                   0x8B

#define API_FRAME_REMOTE_COMMAND_RESPONSE                  0x97
#define API_FRAME_OVER_THE_AIR_FIRMWARE_UPDATE_STATUS      0xA0
#define API_FRAME_ROUTE_RECORD_INDICATOR                   0xA1

#define FRAME_ID_RESPONSE_NO                               0x00
#define FRAME_ID_RESPONSE_YES                              0x01
#define UNKNOWN_DEST_ADD_BYTE_1                            0xFF
#define UNKNOWN_DEST_ADD_BYTE_2                            0xFE

#define AT_COMMAND_RESPONSE_PACKET_SIZE                    22
#define FIFTEEN                                            0x0F

enum
{
   INVALID, VALID
};

