#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define BASE 3
#define SIZE 3

/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
    CONVERT TWO CHAR LETTER STRING TO HEX
 
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
inline int convert_two_char_letter_string_to_hex( char from[] )
{
   if( strlen( from ) != 2 )
   {
      //Serial.println( "The \"convert_two_char_letter_string_to_byte\" "
        //              "function takes only two characters.  Exiting..." );
      exit( -1 );
   }
   
   int msb = 0, lsb = 0;

   switch( from[ 0 ] )
   {
      case 'A':
         msb = 160;
         break;

      case 'B':
         msb = 176;
         break;

      case 'C':
         msb = 192;
         break;

      case 'D':
         msb = 208;
         break;

      case 'E':
         msb = 224;
         break;

      case 'F':
         msb = 240;
         break;

      default:
         break;
   }

   switch( from[ 1 ] )
   {
      case 'A':
         lsb = 10;
         break;

      case 'B':
         lsb = 11;
         break;

      case 'C':
         lsb = 12;
         break;

      case 'D':
         lsb = 13;
         break;

      case 'E':
         lsb = 14;
         break;

      case 'F':
         lsb = 15;
         break;

      default:
         break;
   }
   
   return ( msb + lsb );
}

/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
   CONVERT TWO CHAR NUMBER STRING TO HEX
 
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
inline int convert_two_char_number_string_to_hex( char from[] )
{
   if( strlen( from ) != 2 ) // add print function
      //Serial.println( "The \"convert_two_char_number_string_to_hex\" "
        //              "function takes only two characters.  Exiting..." );
      exit( -1 );
   
   char char_msb = from[ 0 ];
   char char_lsb = from[ 1 ];

   int int_msb = 0;
   int int_lsb = ( int ) char_lsb - 48;

   int i, j = 0, k = 16;

   for( i = 0, j = BASE * k; i < 10; i++, j = BASE * ( k -= 5 ) )
      if( char_msb == ( i + 48 ) )
      {
         int_msb = char_msb - j;
         break;
      }

   return ( int_msb + int_lsb );
}

/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
   CONVERT FIRST NUM AND SECOND CHAR STRING TO HEX
 
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
inline int convert_first_num_and_second_char_string_to_hex( char from[] )
{
   if( strlen( from ) != 2 ) // add print function
      //Serial.println( "The \"convert_two_char_number_string_to_hex\" "
        //              "function takes only two characters.  Exiting..." );
      exit( -1 );

   char char_msb = from[ 0 ];

   int int_msb = 0;
   int lsb = 0;

   int i, j =  0, k = 16;

   for( i = 0, j = BASE * k; i < 10; i++, j = BASE * ( k -= 5 ) )
      if( char_msb == ( i + 48 ) )
      {
         int_msb = char_msb - j;
         break;
      }

   switch( from[ 1 ] )
   {
      case 'A':
         lsb = 10;
         break;

      case 'B':
         lsb = 11;
         break;

      case 'C':
         lsb = 12;
         break;

      case 'D':
         lsb = 13;
         break;

      case 'E':
         lsb = 14;
         break;

      case 'F':
         lsb = 15;
         break;

      default:
         break;
   }

   return ( int_msb + lsb );
}

/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 

 
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
inline int convert_first_char_and_second_num_string_to_hex( char from[] )
{
   if( strlen( from ) != 2 )
   {
      //Serial.println( "The \"convert_two_char_letter_string_to_byte\" "
        //              "function takes only two characters.  Exiting..." );
      exit( -1 );
   }
   
   int msb = 0;
   int lsb = ( int ) from[ 1 ]  - 48;

   switch( from[ 0 ] )
   {
      case 'A':
         msb = 160;
         break;

      case 'B':
         msb = 176;
         break;

      case 'C':
         msb = 192;
         break;

      case 'D':
         msb = 208;
         break;

      case 'E':
         msb = 224;
         break;

      case 'F':
         msb = 240;
         break;

      default:
         break;
   }

   return ( msb + lsb );
}


/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 

 
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */
int convert_two_char_string_to_hex( char from[] )
{
   int hexa;

   if( isdigit( from[ 0 ] ) )
   {
      if( isdigit( from[ 1 ] ) )
         hexa = convert_two_char_number_string_to_hex( from );
      else
         if( isalpha( from[ 1 ] ) )
            hexa = convert_first_num_and_second_char_string_to_hex( from );
   }
   else
      if( isalpha( from[ 0 ] ) )
      {
         if( isalpha( from[ 1 ] ) )
            hexa = convert_two_char_letter_string_to_hex( from );
         else
            if( isdigit( from[ 1 ] ) )
               hexa = convert_first_char_and_second_num_string_to_hex( from );
      }

   return hexa;
}

